function [f,g,H]=likelihood(x,target,data,prior_intrcp,tau,varargin)
%LIKELIHOOD Compute the log-posterior probability of beta in both cases of 
%           normal prior  and improper constant prior on the intercept.

[n,p]=size(data);
h=ones(n,1);
X=[h data];

if isequal(prior_intrcp,'Proper')
    c1=1/varargin{1};
else
    c1=0;
end

z=X*x;
f=-target'*log(max(realmin,normcdf(z)))- (1-target)'*log(max(realmin,normcdf(-z)))+c1*x(1)^2/2+x(2:(p+1))'*x(2:(p+1))/(2*tau);

if nargout>1
    Z1=target.*(normpdf(z)./max(realmin,normcdf(z)));
    Z2=(1-target).*(normpdf(z)./max(realmin,normcdf(-z)));
    g=-X'*Z1+X'*Z2+diag([c1 1/tau*ones(1,p)])*x;

 if nargout>2
    
    d1=target.*(normpdf(z).*(z.*normcdf(z)+normpdf(z)))./(max(realmin,(normcdf(z)).^2));
    D1=diag(d1);
    d2=(1-target).*(normpdf(z).*(-z.*normcdf(-z)+normpdf(z)))./(max(realmin,(normcdf(-z)).^2));
    D2=diag(d2);
    H=X'*D1*X+X'*D2*X+diag([c1 1/tau*ones(1,p)]);

  end
end




    