function [f,g]=maxcond(x,target,c,z,V)
%MAXCOND   Find the maximizer of the conditional posterior distribution  
%          with respect to the vector x.

z=z+V*x;
f=-target'*log(normcdf(z))-(1-target)'*log(normcdf(-z))+(x'*x)/(2*c); %Compute the objective function at x.

if nargout>1
    Z1=target.*(normpdf(z)./normcdf(z));
    Z2=(1-target).*(normpdf(z)./normcdf(-z));
    g=-V'*Z1+V'*Z2+x/c; %Cradient of the function evaluated at x.
end