function [F,J]=firstorder(x,w,f,g)
%FIRSTORDER Find the solution of the zero and first order equation in the 
%           first order method. This method is used for the efficient construction 
%           of RJMCMC proposal distributions.

F=[f+w*log(x(1+w))+x(1:w)'*x(1:w)/(2*x(1+w)^2);x(1:w)/(x(1+w)^2)-g];

if nargout > 1   % two output arguments
   J = [x(1:w)'/(x(1+w)^2) w/x(1+w)-(x(1:w)'*x(1:w))/(x(1+w)^3);
       1/(x(1+w)^2)*eye(w) -2*x(1:w)/(x(1+w)^3)];   % Jacobian of the function evaluated at x
end
       
   