function F=solvesecord(x,c,data,Z1,Z2,Z3,Z4)
%SOLVESECORD Find the solution of the first and second order equation in the 
%            second order method. This method is used for the efficient construction 
%            of RJMCMC proposal distributions.

m = [x(1);x(2)];%Mean of the proposal.
S = [x(3) x(4);
     x(4) x(5)];%Covariance matrix of the proposal.

iS = 1/(x(3)*x(5)-x(4)^2)*[x(5) -x(4);-x(4) x(3)];%Inverse of the covariance matrix.
P = data * S;

F=[S * data' * Z1 - S * data' * Z2 - iS * m;
   - (S * data').^2 * Z3-(S * data').^2 * Z4 - 1/c *[x(3)^2 + x(4)^2; x(5)^2+x(4)^2]+[1;1];
   -(P(:,1).* P(:,2))' * Z3 - (P(:,1).* P(:,2))' * Z4 - 1/c * (x(3)*x(4)+x(4)*x(5))];

